<?php

namespace Lean\Console\Lib\Database;

use Notes\Common\ReflectedProperty;

class Definition
{
    public function __construct(
        public string               $entity,
        public string|null          $field = null,
        public array|null|ReflectedProperty           $definition = null,
        public null|Modifier|array  $modifier = null,
        public null|Definition      $previous = null,
        public null|string          $action = null,
    ) {}

    public function toArray() : array
    {
        return array_filter(get_object_vars($this));
    }
}